C --- HERWIG adjustable parameters

C --- Parton distributions:

      IF (PDFPH.eq.9003) THEN
	MODPDF(1)=3
	AUTPDF(1)='SaSph'
      ELSE IF (PDFPH.eq.9001) THEN
	MODPDF(1)=1
	AUTPDF(1)='SaSph'
      ELSE IF (PDFPH.eq.5003) THEN
	MODPDF(1)=3
	AUTPDF(1)='GRVph'
      ELSE IF (PDFPH.eq.3001) THEN
	MODPDF(1)=1
	AUTPDF(1)='LAC'
      ELSE IF (PDFPH.eq.8002) THEN
	MODPDF(1)=2
	AUTPDF(1)='WHIT-G'
      ELSE
	print*,'You have chosen an unsupported photon pdf!'
      ENDIF

C --- Should obviously use same PDF for each photon!
      MODPDF(2)=MODPDF(1)
      AUTPDF(2)=AUTPDF(1)
      
      PTMIN=PTMIN1
      JMBUG=DEBUG
      
C---  Turn MI on(1) or off(0)
      IF (MION.EQ.1.OR.MION.EQ.3) THEN
         MSFLAG=1
      ELSE
         MSFLAG=0
      ENDIF
      
      
C---  For other cases, cuts are on the virtuality of the 'on-shell'
c     photon
      Q2WWMN=0.
      Q2WWMX=4.
C---  And its energy fraction
C     For HERA tuning these can be set to exclude the extremes,
C     since no measurements go higher than 0.9. However, for
C     the linear collider may want to expand to the kinematic limit.
      YWWMIN=0.
      YWWMAX=1.
C---  and the minimum mass of the hadronic system???????????
c      WHMIN=2.
C---  Set this back to default just incase it affects these processes!
c      EMMIN=0D0
      
      
      IFLMIN=1
      
c     To generate weighted events set NOWGT false
      NOWGT=.TRUE.
c     (weighting doesn't work with LEP program)
c      NOWGT=.NOT.WEIGHTING
      IF (.NOT.NOWGT) THEN
         IF (HZPTPOW.GT.-999.)  PTPOW=DBLE(HZPTPOW) 
         WRITE(*,*) 'Running with weighted events.'
      ELSE
         WRITE(*,*) 'Running with unweighted events.'
      ENDIF

      IF (HZPTRMS.GT.-999.)  PTRMS=DBLE(HZPTRMS) 
      IF (HZQSPAC.GT.-999.)  QSPAC=DBLE(HZQSPAC) 
      IF (HZQCDLAM.GT.-999.) QCDLAM=DBLE(HZQCDLAM) 
      IF (HZVPCUT.GT.-999.)  VPCUT=DBLE(HZVPCUT) 
      IF (HZISPAC.GT.-999)   ISPAC=HZISPAC 
      IF (HZIFLMAX.GT.-999)  IFLMAX=HZIFLMAX
      IF (HZNFLAV.GT.-999)  NFLAV=HZNFLAV
      IF (PTMAX1.GT.-999.)   PTMAX=PTMAX1
      IF (HZPHRADIUS.GT.-999.) THEN
         JMU2=JMRAD(59)*DBLE(HZPHRADIUS) 
         JMV2=JMRAD(59)*DBLE(HZPHRADIUS) 
      ENDIF
      IF (HZPHAD.GT.-999) PHAD = HZPHAD

*       Original ZEUS settings
*       QCDLAM=0.20 (def 0.18)
*       VPCUT=1.0   (def 0.4)
*       QSPAC=2.0   (def 2.5)
*       PTRMS=0.7   (def 0.0)
*       SUDORD=2
*       PSPLT=1
*       CLMAX=??

      NETRY=20
      MAXER=MAXEV/5
      
      IF (HZVQCUT.GT.-999) VQCUT = HZVQCUT
      IF (HZPRSOF.GT.-999) PRSOF = HZPRSOF
      IF (HZIOPREM.GT.-999) IOPREM = HZIOPREM
      IF (HZBTCLM.GT.-999) BTCLM = HZBTCLM
C --- DIS tuned parameters (UCL/HEP96-05)
      IF (HZCLMAX.GT.-999) CLMAX = HZCLMAX
C       CLMAX=5.5
      WRITE(*,*) 'CLMAX IS ',CLMAX,' (DEFAULT IS 3.35)'

#ifdef HERWIG59
      IF (HZPSPLT1.GT.-999) PSPLT = HZPSPLT1
      PSPLT=0.65
      WRITE(*,*) 'PSPLT IS ',PSPLT,' (DEFAULT IS 1)'
#else
      IF (HZPSPLT1.GT.-999) PSPLT(1) = HZPSPLT1
      IF (HZPSPLT2.GT.-999) PSPLT(2) = HZPSPLT2
C      PSPLT(1)=0.65
C      PSPLT(2)=0.65
      WRITE(*,*) 'PSPLT(1) AND (2) ARE ',PSPLT(1),PSPLT(2)
     &     ,' (DEFAULT IS 1)' 
#endif      
