C     --- HERWIG adjustable parameters

      PTMIN=PTMIN1
      BEAMS='pp'
      JMBUG=DEBUG

C --- Parton distributions:
      IF (PDFPR.eq.5005) THEN
         MODPDF(1)=5
         AUTPDF(1)='GRV'
         MODPDF(2)=5
         AUTPDF(2)='GRV'
      ELSE IF (PDFPR/1000.eq.4) THEN
C     CTEQ 
         MODPDF(1)=MOD(PDFPR,100)
         AUTPDF(1)='CTEQ'
         MODPDF(2)=MOD(PDFPR,100)
         AUTPDF(2)='CTEQ'
      ELSE IF (PDFPR/1000.eq.3) THEN
C     MRS
         MODPDF(1)=MOD(PDFPR,100)
         AUTPDF(1)='MRS'
         MODPDF(2)=MOD(PDFPR,100)
         AUTPDF(2)='MRS'
      ELSE IF (PDFPR.eq.4030) THEN
C     CTEQ 3M
         MODPDF(1)=30
         AUTPDF(1)='CTEQ'
         MODPDF(2)=30
         AUTPDF(2)='CTEQ'
      ELSE IF (PDFPR.eq.3041) THEN
C     MRS 
         MODPDF(1)=41
         AUTPDF(1)='MRS'
         MODPDF(2)=41
         AUTPDF(2)='MRS'
      ELSE
         WRITE(*,*) 'hrwparam_tevatron.inc: Unknown PDF',PDFPR
c 4001    FORMAT(2X,I8,'is an unsupported proton pdf for HZTOOL.',//
c     & ,'This is very easy to fix. Just add it to hrwparam_lhc.inc')
      ENDIF


c     Process (if it is not the default)
      IF (HZPROC.NE.1) THEN
         IPROC=HZPROC
      ENDIF

c     Higgs mass
      If (MHIGGS.GT.0) RMASS(201)=MHIGGS

C---  Turn MI on(1) or off(0)
      IF (MION.EQ.1.OR.MION.EQ.3) THEN
         MSFLAG=1
      ELSE
         MSFLAG=0
      ENDIF
      
      IF (IPROC.eq.11500.or.IPROC.eq.1500) THEN

c     ok

      ELSE
         
         WRITE(*,*) 'hrwparam_tevatron.inc: unknown process ',IPROC
c 4000    FORMAT(2X,I8,'is not a process known to HZTOOL,',//,2X
c     &        ,'but will have a go...')
         
      ENDIF
      
      IFLMIN=1
      IFLMAX=5
      
c     To generate weighted events set NOWGT false
      NOWGT=.NOT.WEIGHTING
      IF (.NOT.NOWGT) THEN
         WRITE(*,*) 'Running with weighted events.'
         IF (HZPTPOW.GT.-999.)  PTPOW=DBLE(HZPTPOW) 
      ELSE
         WRITE(*,*) 'Running with unweighted events.'
      ENDIF

      IF (HZPTRMS.GT.-999.)  PTRMS=DBLE(HZPTRMS) 
      IF (HZPTPOW.GT.-999.)  PTPOW=DBLE(HZPTPOW) 
      IF (HZQSPAC.GT.-999.)  QSPAC=DBLE(HZQSPAC) 
      IF (HZQCDLAM.GT.-999.) QCDLAM=DBLE(HZQCDLAM) 
      IF (HZVPCUT.GT.-999.)  VPCUT=DBLE(HZVPCUT) 
      IF (HZISPAC.GT.-999)   ISPAC=HZISPAC 
      IF (HZIFLMAX.GT.-999)  IFLMAX=HZIFLMAX
      IF (HZNFLAV.GT.-999)  NFLAV=HZNFLAV
      IF (PTMAX1.GT.-999.)   PTMAX=PTMAX1
      IF (HZPRADIUS.GT.-999.) THEN
         JMU2=JMRAD(73)*DBLE(HZPRADIUS) 
         JMV2=JMRAD(73)*DBLE(HZPRADIUS) 
      ENDIF

*       Original ZEUS settings
*       QCDLAM=0.20 (def 0.18)
*       VPCUT=1.0   (def 0.4)
*       QSPAC=2.0   (def 2.5)
*       PTRMS=0.7   (def 0.0)
*       SUDORD=2
*       PSPLT=1
*       CLMAX=??

      NETRY=20
      
      IF (HZVQCUT.GT.-999) VQCUT = HZVQCUT
      IF (HZPRSOF.GT.-999) PRSOF = HZPRSOF
      IF (HZIOPREM.GT.-999) IOPREM = HZIOPREM
      IF (HZBTCLM.GT.-999) BTCLM = HZBTCLM
C --- DIS tuned parameters (UCL/HEP96-05)
      IF (HZCLMAX.GT.-999) CLMAX = HZCLMAX
C       CLMAX=5.5
      WRITE(*,*) 'CLMAX IS ',CLMAX,' (DEFAULT IS 3.35)'

#ifdef HERWIG59
      IF (HZPSPLT1.GT.-999) PSPLT = HZPSPLT1
      PSPLT=0.65
      WRITE(*,*) 'PSPLT IS ',PSPLT,' (DEFAULT IS 1)'
#else
      IF (HZPSPLT1.GT.-999) PSPLT(1) = HZPSPLT1
      IF (HZPSPLT2.GT.-999) PSPLT(2) = HZPSPLT2
C      PSPLT(1)=0.65
C      PSPLT(2)=0.65
      WRITE(*,*) 'PSPLT(1) AND (2) ARE ',PSPLT(1),PSPLT(2)
     &     ,' (DEFAULT IS 1)' 
#endif      

      
