c Include file for SPS conditions in Pythia
c Basically a copy of pyparam_tevatron.inc
c
c Beam energies default to 100 GeV (sqrt(s)=200 GeV)
c N.B. Override energies for other running conditions
 
      BEAMS='pp'

      P(1,1)=0.
      P(1,2)=0.
      P(1,3)=-100.

      P(2,1)=0.
      P(2,2)=0.
      P(2,3)=100.

c     Weighted events!
      IF (WEIGHTING) THEN
         MSTP(142)=1
      ENDIF
      
C     Soft procs on
*     MSEL=2
C     Soft procs off
      IF (mselect.gt.-999) msel=mselect
      
      IF (mion.EQ.0) THEN
         MSTP(81)=0
      ELSE
         mstp(81) = 1
         mstp(82) = mion
      ENDIF

      IF (MSTP(81).eq.1) THEN
	write(*,*)'Multiple Interactions are ON'
      ELSE
	write(*,*)'Multiple Interactions are OFF'
      ENDIF

      write(*,*) 'ckin(3),ptmin1',ckin(3),ptmin1
      
c     Force PYTHIA to use the hard scattering cross section rather than
c     the total in its eikonlisation.
c      IF (SIGMAND.GT.0.0) THEN
c         SIGT(0,0,5)=SIGMAND
c         MSTP(31)=0
c      ENDIF

C     PtMin for hardest scatter.
      IF (ptmin1.GE.0) THEN
         ckin(3)=ptmin1
      ENDIF

      WRITE(*,*) 'ckin(3),ptmin1',ckin(3),ptmin1


      IF (ptrmspr.GT.-999) THEN
         IF (mstp(91).EQ.1) THEN
            parp(91)=ptrmspr
         ELSE IF (mstp(91).EQ.2) THEN
            parp(92)=ptrmspr
         ENDIF
      ENDIF

      mstp(51)=pdfpr
      mstp(52)=2

c     proton structure function (GRV 94 LO)
*      MSTP(51)=5005

c     photon structure function (GRV-G LO)
*      MSTP(55)=5003
*      MSTP(56)=2

c     photon structure function (SaS 2D)
*      MSTP(55)=9003
*      MSTP(56)=2

c     photon structure function (SaS 1D)
*      MSTP(55)=9001
*      MSTP(56)=2

c     photon structure function (LAC1)
*      MSTP(55)=3001
*      MSTP(56)=2

c     photon structure function (WHIT2)
*      MSTP(55)=8002
*      MSTP(56)=2


*     Higgs Mass
      IF (MHIGGS.GT.0) PMAS(25,1)=MHIGGS         
      WRITE(*,*) 'Higgs mass =',mhiggs,PMAS(25,1)

C     Number of quark flavours used
      MSTP(58)=5

C ww scattering 		
      IF (proctype(1:4).eq.'wwww') THEN
         msel=0
*     ww subprocess
         MSUB(77)=1
*     Must be set !
         PARP(44) = 1000
*     select pade
*     MSTP(46)=3
*     select N/D
         MSTP(46)=4
*     Generate all charge combinations 
         MSTP(45)=3	
         
      endif
* zz -> zz scattering	
      if (proctype.eq.'zzzz') then
         MSEL=0
* zz subprocess
         MSUB(71)=1
*     Must be set !
         PARP(44) = 1000
*     select pade
*     MSTP(46)=3
*     select N/D
         MSTP(46)=4
*     Generate all charge combinations 
         MSTP(45)=3	
         
      endif
*     zw -> zw scattering	
      if (proctype.eq.'zwzw') then
         MSEL=0
*     zz subprocess
         MSUB(73)=1
*     Must be set !
         PARP(44) = 1000
*     select pade
*     MSTP(46)=3
*     select N/D
         MSTP(46)=4
*     Generate all charge combinations 
         MSTP(45)=3	
      endif
*     ww -> zz scattering	
      if (proctype.eq.'wwzz') then
         MSEL=0
*     zz subprocess
         MSUB(76)=1
*     Must be set !
         PARP(44) = 1000
*     select pade
*     MSTP(46)=3
*     select N/D
         MSTP(46)=4
*     Generate all charge combinations 
         MSTP(45)=3	
      endif
*     zz -> ww scattering	
      if (proctype.eq.'zzww') then
         MSEL=0
*     zz subprocess
         MSUB(72)=1
*     Must be set !
         PARP(44) = 1000
         msub(77)=1
*     select pade
*     mstp(46)=3
*     select n/d
         mstp(46)=4
*     generate all charge combinations 
         mstp(45)=3	
      endif
*     WW -> Higgs -> WW
*     (narrow width approximation)	
      if (proctype.eq.'higgs') then
         MSEL=0
	 MSUB(123)=1
	 MSUB(124)=1
	 MSTP(49)=0
      endif
      IF (proctype.eq.'ttbar') THEN
         msel=6
         msub(81)=1
         msub(82)=1
      ENDIF
      IF (proctype.eq.'wjets') then
         MSEL=14
      ENDIF
      IF (proctype.eq.'QCD') then
         MSEL=1
      ENDIF
      IF (proctype.eq.'mbias') THEN
         write(*,*)
     &        'Switching to minimum bias event generation ',
     &        'including diffractive dissociation'
         CKIN(3)=0.0
         msel=0
         
         msub(11)=1
         msub(12)=1
         msub(13)=1
         msub(28)=1
         msub(53)=1
         msub(68)=1
         
         msub(94)=1             ! Double-diffraction
         msub(95)=1
         msub(96)=1
      ENDIF

      









