      PROGRAM HRW_JIMMY
c     -----------------
c     Main program to make a bunch of JIMMY test histograms
c     -------------------------------------------------------
c     HERWIG/JIMMY COMMONS. HERWIG COMMON INCLUDES AN IMPLICIT NONE.
#ifdef HERWIG65
#include "herwig65.inc"
#include "jimmy.inc"
#endif

#ifdef HERWIG64
#include "herwig64.inc"
#include "jimmy30.inc"
#endif

*     HZTOOL COMMONS
#include "heracmn.inc"
#include "hzhbook.inc"

      LOGICAL ABORT

C     HBOOK common.
      INTEGER NWPAWC,H
      PARAMETER (NWPAWC=1000000)
      COMMON/PAWC/H(NWPAWC)

      INTEGER icycle,loop,status

C     Variables related to the number of events to be generated.
      REAL tot_qcd, qcd_xsec

      DOUBLE PRECISION hwrset, dummy

      CHARACTER*3 PROCTYPE

C     Variables for parameter setting etc.
#include "hzcontrol.inc"

      INTEGER IPUNIT,LENOCC
      PARAMETER(IPUNIT=5)
      CHARACTER*80 STEM

C     Reserve space for histograms
      CALL HLIMIT(NWPAWC)
      
C     Choose generator.
      GEN='HRW'

      tot_qcd=0
      rand_num1=0
      rand_num2=0

      WRITE(*,*) 'File stem?'
      READ(*,3000) stem
 3000 FORMAT(A80)
      stem = stem(1:LENOCC(stem))

      WRITE(*,*) 'hrw_jimmy.fpp $Date: 2004/03/18 15:48:32 $'  

      WRITE(*,*) 'reading from ',stem(1:LENOCC(stem))//'.input'

      OPEN(UNIT=IPUNIT,FILE=STEM(1:LENOCC(STEM))//'.input',STATUS
     &     ='UNKNOWN')

C *** Open up our histograms file ***
      CALL HROPEN(45,'HISTO',STEM(1:LENOCC(STEM))//'.rz','N',1024,status
     &     )
      PRINT*,"Histogram file opened"

c     create a dummy histogram with the version date as its title.
      CALL HBOOK1(-1,'$Date: 2004/03/18 15:48:32 $',2,0.,1.,0.0)

c     Read control cards into hzcontrol common.
      CALL HZCARDS


c     =============================================================
      IF (HZBEAMS.EQ.3) THEN
c     =============================================================
c
c               HERA running with 920 GeV protons
c
c     =============================================================

         WRITE (*,*)
         WRITE (*,*) '================================================'
         WRITE (*,*) ' HERA running with 27.52 GeV e+ and 920.0 GeV p'
         WRITE (*,*) '================================================'

c     Set beam energies
         PART1='E+  '
         PART2='P   '
         PBEAM1=27.52
         PBEAM2=920.0

      ELSE IF (HZBEAMS.EQ.251) THEN

c     =============================================================
c
c       LHC running with nominal energies
c
c     =============================================================

         WRITE (*,*)
         WRITE (*,*) '================================================'
         WRITE (*,*) ' LHC running with nominal energies'
         WRITE (*,*) '================================================'

c     Set beam energies
         PART1='P  '
         PART2='P  '
         PBEAM1=7000.0
         PBEAM2=7000.0
      ELSE

         WRITE(*,*) 'UNKNOWN HZBEAMS ID'

      ENDIF

C     9130 is direct, 1500 is resolved +10000 to suppress S.U.E.
c      IPROC=11500
      IPROC=HZPROC

C     HERWIG initialization
      CALL HWIGIN
      CALL JIMMIN

C     --- HERWIG adjustable parameters

      IF (HZBEAMS/100.EQ.0.OR.HZBEAMS/100.EQ.2) THEN
C     --- Proton parton distributions:
         IF (PDFPR.eq.5005) THEN
            MODPDF(2)=5
            AUTPDF(2)='GRV'
         ELSE IF (PDFPR.eq.4030) THEN
C     CTEQ 3M
            MODPDF(2)=30
            AUTPDF(2)='CTEQ' 
         ELSE IF (PDFPR/1000.eq.4) THEN
C     CTEQ 
            MODPDF(2)=MOD(PDFPR,100)
            AUTPDF(2)='CTEQ'
         ELSE IF (PDFPR/1000.eq.3) THEN
C     MRS
            MODPDF(2)=MOD(PDFPR,100)
            AUTPDF(2)='MRS'
         ELSE IF (PDFPR.eq.3041) THEN
C     MRS 
            MODPDF(2)=41
            AUTPDF(2)='MRS'
         ELSE
            WRITE(*,4001) PDFPR
            STOP
         ENDIF
      ENDIF

      IF (HZBEAMS/100.LT.2) THEN
C     --- Photon parton distributions:
         IF (PDFPH.eq.9003) THEN
C     SaS2D
            MODPDF(1)=3
            AUTPDF(1)='SaSph'
         ELSE IF (PDFPH.eq.9004) THEN
C     SaS2M
            MODPDF(1)=4
            AUTPDF(1)='SaSph'
         ELSE IF (PDFPH.eq.9002) THEN
C     SaS1M
            MODPDF(1)=2
            AUTPDF(1)='SaSph'
         ELSE IF (PDFPH.eq.9001) THEN
C     SaS1D
            MODPDF(1)=1
            AUTPDF(1)='SaSph'
         ELSE IF (PDFPH.eq.5003) THEN
C     GRV 92 LO
            MODPDF(1)=3
            AUTPDF(1)='GRVph'
         ELSE IF (PDFPH.eq.3001) THEN
C     LAC1 LO  
            MODPDF(1)=1
            AUTPDF(1)='LAC'
         ELSE IF (PDFPH.eq.8002) THEN
C     WHIT 2 LO  
            MODPDF(1)=2
            AUTPDF(1)='WHIT-G'
         ENDIF

      ENDIF

      IF (HZBEAMS/100.EQ.2) THEN
         MODPDF(1)=MODPDF(2)
         AUTPDF(1)=AUTPDF(2)
      ELSE IF (HZBEAMS/100.EQ.1) THEN
         MODPDF(2)=MODPDF(1)
         AUTPDF(2)=AUTPDF(1)
      ENDIF
      Write(*,*) MOD(HZBEAMS,100), autpdf(1), autpdf(2)

      JMBUG=DEBUG

      PTMIN=HZPTMIN
#ifdef HERWIG65
      PTJIM=HZPTJIM
#endif

C---  Turn MI on(1) or off(0)
      IF (MION.EQ.1.OR.MION.EQ.3) THEN
         MSFLAG=1
      ELSE
         MSFLAG=0
      ENDIF

      Q2WWMN=0.
      Q2WWMX=4.
      YWWMIN=0.01
      YWWMAX=0.99
      
      IFLMIN=1

      IF (HZPTRMS.GT.-999.)  PTRMS=DBLE(HZPTRMS) 
      IF (HZQSPAC.GT.-999.)  QSPAC=DBLE(HZQSPAC) 
      IF (HZQCDLAM.GT.-999.) QCDLAM=DBLE(HZQCDLAM) 
      IF (HZVPCUT.GT.-999.)  VPCUT=DBLE(HZVPCUT) 
      IF (HZISPAC.GT.-999)   ISPAC=HZISPAC 
      IF (HZIFLMAX.GT.-999)  IFLMAX=HZIFLMAX
      IF (HZNFLAV.GT.-999)   NFLAV=HZNFLAV
      IF (HZPTMAX.GT.-999.)   PTMAX=HZPTMAX
      IF (HZPRADIUS.GT.-999.) THEN
         JMU2=JMRAD(73)*DBLE(HZPRADIUS) 
      ENDIF
      IF (HZPHRADIUS.GT.-999.) THEN
         JMV2=JMRAD(59)*DBLE(HZPHRADIUS) 
      ENDIF

      IF (HZPHAD.GT.-999) PHAD = HZPHAD

      NETRY=20
      MAXER=MAXEV/5
      
      IF (HZVQCUT.GT.-999) VQCUT = HZVQCUT
      IF (HZPRSOF.GT.-999) PRSOF = HZPRSOF
      IF (HZIOPREM.GT.-999) IOPREM = HZIOPREM
      IF (HZBTCLM.GT.-999) BTCLM = HZBTCLM
      IF (HZCLMAX.GT.-999) CLMAX = HZCLMAX
      WRITE(*,*) 'CLMAX IS ',CLMAX,' (DEFAULT IS 3.35)'

      IF (HZPSPLT1.GT.-999) PSPLT(1) = HZPSPLT1
      IF (HZPSPLT2.GT.-999) PSPLT(2) = HZPSPLT2
      WRITE(*,*) 'PSPLT(1) AND (2) ARE ',PSPLT(1),PSPLT(2)
     &     ,' (DEFAULT IS 1)' 

c --------------------------

      IF (MION.GT.1) THEN
         WRITE(*,*) 'SOFT UNDERLYING EVENT IS TURNED ON'
         IPROC=MOD(IPROC,10000)
      ENDIF

      WRITE(*,*) 'MSFLAG=',MSFLAG

C     More initialization.
      CALL HWUINC
      CALL HWEINI            
      CALL JMINIT

      NRN(1)=RAND_NUM1
      NRN(2)=RAND_NUM2
      DUMMY=HWRSET(NRN)

      MAXEV=NEV_QCD
      MAXER=MAXEV/5

      WRITE(*,*) 'Number of resolved events to generate =',NEV_QCD

C     Random number
      WRITE(*,*) 'Using seeds',NRN(1),NRN(2)
      IF (.NOT.NOWGT) WRITE(*,*) 'Weighted Events'

C     Initialise JIMMY test plots and fill the
C     ones based on the starting array.
      CALL JIMTEST(1)
      IF (HZBEAMS/100.EQ.0) THEN
         CALL HZ95033(1001)
         CALL HZ01220(1001)
         CALL HZ95033(2001)
         CALL HZ01220(2001)
      ELSE IF (HZBEAMS/100.EQ.2) THEN
        CALL FIELDSTUART(1)               
      ENDIF

      PRINT*,"Initialised RESOLVED"

C     Loop over events.
      DO LOOP=1,NEV_QCD
 50      CONTINUE
         
C---  INITIALISE EVENT
         CALL HWUINE
C---  GENERATE HARD SUBPROCESS
         CALL HWEPRO
C---  GENERATE PARTON CASCADES
         CALL HWBGEN
C---  GENERATE MULTIPARTON INTERACTIONS
         IF (MSFLAG.EQ.1) THEN
            CALL HWMSCT(ABORT)
            IF (ABORT) GOTO 50
         ENDIF
C---  DO HEAVY QUARK DECAYS
         CALL HWDHOB
C---  DO CLUSTER HADRONIZATION
         CALL HWCFOR
C---  DO CLUSTER DECAY
         CALL HWCDEC
C---  DO UNSTABLE PARTICLE DECAYS
         CALL HWDHAD
C---  DO HEAVY FLAVOUR DECAYS
         CALL HWDHVY
C---  ADD SOFT UNDERLYING EVENT IF NEEDED
         CALL HWMEVT
C---  FINALISE EVENT
         CALL HWUFNE
         
         IF (IERROR.NE.0) GOTO 50
         
         CALL HZFILHEP
         
         IF (mod(LOOP,1000).eq.0) THEN
            PRINT*,"RESOLVED event ",LOOP
         ENDIF

         CALL JIMTEST(2)
         IF (HZBEAMS/100.EQ.0) THEN
            CALL HZ95033(2002)
            CALL HZ01220(2002)
         ELSE IF (HZBEAMS/100.EQ.2) THEN
            CALL FIELDSTUART(2)               
         ENDIF

         TOT_QCD=TOT_QCD+1

      ENDDO
      
C     Finish off Herwig Routines
      CALL HWEFIN
      CALL JMEFIN
      
C     Close histograms.
      Ntot=TOT_QCD
      XSEC=AVWGT

c     Final state particles
      CALL JIMTEST(3)
      IF (HZBEAMS/100.EQ.0) THEN
         CALL HZ95033(2003)
         CALL HZ01220(2003)
      ELSE IF (HZBEAMS/100.EQ.2) THEN
         CALL FIELDSTUART(3)               
      ENDIF
      
      PRINT*,"Terminated RESOLVED"

c     =============================================================

      CALL HCDIR('//PAWC',' ')
      CALL HCDIR('//HISTO',' ')
      CALL HROUT(0,icycle,'T')
      CALL HREND('HISTO')
      PRINT*,"Outputted and ended"              
      
 4001 FORMAT(2X,I8,'is an unsupported proton pdf for HZTOOL.',//
     &  ,'This is very easy to fix. Just add it to hrwparam_hera.inc'
     &     )

      END

      SUBROUTINE hwaend
      RETURN
      END
      SUBROUTINE JIMTEST(iflag)
C =============================================================
#ifdef HERWIG65
#include "herwig65.inc"
#include "jimmy.inc"
#else
#include "herwig64.inc"
#include "jimmy30.inc"
#endif

#include "heracmn.inc"
#include "hzhbook.inc"

      INTEGER iflag, jscat, iz, i, j

      INTEGER njets, ijet
      DOUBLE PRECISION jets(50,8)
      REAL ptscat(25), tmp

      IF (iflag.EQ.1) THEN

         CALL HCDIR('//HISTO',' ')
         CALL HMDIR('JIMTEST','S')
         CALL HCDIR('//PAWC',' ')
         CALL HMDIR('JIMTEST','S')

         DO IZ=0, NPSIMP
           
            CALL HBOOK1(1+IZ,'Scatters per event (initial)'
     $           ,20,0.0,20.0,0.0)

            DO JSCAT=1,20
               CALL HFILL(1+IZ,FLOAT(JSCAT),0.0,SNGL(JMARRY(4+JSCAT
     $              ,IZ)))
            ENDDO

         ENDDO

         CALL HBOOK1(100,'Scatters per event (gen)'
     $        ,20,0.0,20.0,0.0)

         CALL HBOOK1(101,'ET scatter 1'
     $        ,100,0.0,50.0,0.0)

         CALL HBOOK1(102,'ET scatter 2'
     $        ,100,0.0,50.0,0.0)

         CALL HBOOK1(103,'ET scatter 3'
     $        ,100,0.0,50.0,0.0)

         CALL HBOOK1(104,'ET all scatters'
     $        ,100,0.0,50.0,0.0)

      ELSE IF (iflag.EQ.2) THEN

         CALL HCDIR('//HISTO/JIMTEST',' ')
         CALL HCDIR('//PAWC/JIMTEST',' ')

c     Get the LO partons
         CALL HZLOP(NJETS,JETS,IERROR)

         JSCAT=0
         DO IJET=1,NJETS,2
            JSCAT=JSCAT+1
            PTSCAT(JSCAT)=JETS(IJET,3)
         ENDDO

         DO I=1,JSCAT
            DO J=I,JSCAT
               IF (PTSCAT(J).GT.PTSCAT(I)) THEN
                  TMP=PTSCAT(J)
                  PTSCAT(J)=PTSCAT(I)
                  PTSCAT(I)=TMP
               ENDIF
            ENDDO
         ENDDO

c     for test purposes, only look at events with a >5GeV scatter.
         IF (PTSCAT(1).LT.5.0) RETURN

         CALL HFILL(100,FLOAT(NSCAT),0.0,1.0)

         CALL HFILL(101,PTSCAT(1),0.0,1.0)
         IF (NSCAT.GT.1) CALL HFILL(102,PTSCAT(2),0.0,1.0)
         IF (NSCAT.GT.2) CALL HFILL(103,PTSCAT(3),0.0,1.0)
         DO I=1,JSCAT
            CALL HFILL(104,PTSCAT(JSCAT),0.0,1.0)            
         ENDDO


      ELSE IF (iflag.EQ.3) THEN

         CALL HCDIR('//HISTO/JIMTEST',' ')
         CALL HCDIR('//PAWC/JIMTEST',' ')

      ELSE
         WRITE(*,*) 'JIMTEST: UNKNOWN IFLAG'
      ENDIF

      RETURN
      END















