      PROGRAM PYT6206
c     ------------------------------------------------------------
c     
c     Main program to make plots for JetWeb
c     reads control cards from file
c     calls event generation depending on input beams
c
c     ------------------------------------------------------------
      IMPLICIT NONE

      INTEGER NWPAWC,H
      PARAMETER (NWPAWC=9000000)
      COMMON/PAWC/H(NWPAWC)
      
      INTEGER istat,icycle,iparam

      INTEGER ipunit,lenocc
      PARAMETER(ipunit=5)
      CHARACTER*80 stem
      EXTERNAL pydata,pyevwt 

#include "hzhbook.inc"
#include "hzcontrol.inc"
#include "hepevtp.inc"
#include "heracmn.inc"

      DO iparam=1,200
         hzmstp(iparam)=-9999
         hzparp(iparam)=-9999.
         hzmstj(iparam)=-9999
         hzparj(iparam)=-9999.
      ENDDO

***********************************************
**                                           **
**    read control file and open output file **
**                                           **
***********************************************

      WRITE(*,*) 'File stem?'
      READ(*,3000) stem
 3000 FORMAT(A80)
      stem = stem(1:LENOCC(stem))

      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
      Print*,'* pyt6206.fpp $Date: 2004/08/23 13:34:10 $'  
      PRINT*,'* Reading cards from ',stem(1:LENOCC(stem))//'.input'
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''

      OPEN(UNIT=ipunit,FILE=stem(1:LENOCC(stem))//'.input',status
     &     ='UNKNOWN')

C     Reserve space for histograms
      CALL HLIMIT(nwpawc)

C     Generator name.
      gen='PYT'

c     Read in control cards
      CALL HZCARDS

C     *** Open up our histograms file ***
      CALL HROPEN(45,'HISTO',stem(1:LENOCC(stem))//'.rz','N',1024,istat)

      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
      PRINT*,"* Histogram file opened: ",stem(1:LENOCC(stem)),'.rz'
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''

***************************************************
**                                               **
**    choose event generation depending on beams **
**                                               **
***************************************************

      if (hzbeams.eq.1) then

         PRINT*,''
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,'*'
         PRINT*,'* Input beams = ep'
         PRINT*,'*'
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,''

         CALL PYTEP

      else if (hzbeams.eq.2) then

         PRINT*,''
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,'*'
         PRINT*,'* Input beams = ee'
         PRINT*,'*'
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,''

         CALL PYTEE

      else if (hzbeams.eq.3) then

         PRINT*,''
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,'*'
         PRINT*,'* Input beams = ppbar'
         PRINT*,'*'
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,''

         CALL PYTPP

      else

         PRINT*,''
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,'*'
         PRINT*,'* Unknown input beams: ',hzbeams
         PRINT*,'*'
         PRINT*,'**************************************************',
     +        '*****'
         PRINT*,''

      endif

*******************************************
**                                       **
**    End of event generation runs       **
**                                       **
*******************************************

C     *** Close off histograms ***
      
      CALL HCDIR('//PAWC',' ')
      CALL HCDIR('//HISTO',' ')
      CALL HROUT(0,icycle,'T')
      CALL HREND('HISTO')
      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
      PRINT*,"* Outputted and ended"	
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''
      
      END






