      DOUBLE PRECISION FUNCTION HZHWAVRG(nev,msflag)
C     ---------------------------------------------------------------------
C     Returns the average charged multiplicity for PYTHIA events.
C     PYTHIA is assumed to have been already initialised.
C     Author: Jon Butterworth
C     ---------------------------------------------------------------------
      IMPLICIT NONE

#include "hepevtp.inc"

      INTEGER nev, navrg, i, evloop, msflag, ierror
      LOGICAL abort

      navrg = 0
      
      DO evloop=1,nev
 53      CONTINUE
  
C---  INITIALISE EVENT
         CALL HWUINE
C---    GENERATE HARD SUBPROCESS
         CALL HWEPRO
C---  GENERATE PARTON CASCADES
         CALL HWBGEN

C---  GENERATE MULTIPARTON INTERACTIONS
         IF (MSFLAG.EQ.1) THEN
            CALL HWMSCT(ABORT)
            IF (ABORT) GOTO 53
         ENDIF

C---  DO HEAVY OBJECT DECAYS
#ifdef HERWIG59 
         CALL HWDHQK
#else
         CALL HWDHOB
#endif
C---  DO CLUSTER HADRONIZATION
         CALL HWCFOR
C---  DO CLUSTER DECAY
         CALL HWCDEC
C---  DO UNSTABLE PARTICLE DECAYS
         CALL HWDHAD
C---  DO HEAVY FLAVOUR DECAYS
         CALL HWDHVY
C---  ADD SOFT UNDERLYING EVENT IF NEEDED
         CALL HWMEVT
C---  FINALISE EVENT
         CALL HWUFNE
         
         IF (IERROR.NE.0) GOTO 53
         
         CALL HZFILHEP
                  
         do I=1,NHEP
            
            if((IDHEP(I).eq.11).or.(IDHEP(I).eq.-11).or. 
     &           (IDHEP(I).eq.13).or.(IDHEP(I).eq.-13).or.
     &           (IDHEP(I).eq.15).or.(IDHEP(I).eq.-15).or.
     &           (IDHEP(I).eq.2212).or.(IDHEP(I).eq.-2212).or.
     &           (IDHEP(I).eq.211).or.(IDHEP(I).eq.-211).or.
     &           (IDHEP(I).eq.321).or.(IDHEP(I).eq.-321).or.
     &           (IDHEP(I).gt.3000).or.(IDHEP(I).lt.-3000))then
               
               navrg = navrg + 1
            endif
         enddo
         
      ENDDO
      
C     Finish off Herwig Routines
      CALL HWEFIN

      hzhwavrg = navrg*1.d0/nev

      RETURN
      END
